/*
** vbcc-PowerOpen/WarpOS Lowlevel write() function
**
** v0.1 31.07.98 phx
*/

#include <stdio.h>
#include <errno.h>

#include <powerpc/powerpc.h>
#include <clib/powerpc_protos.h>

extern APTR DOSBase;


long _write(char *fh,void *buf,long size)
{
  struct PPCArgs pa;
  long n;

  if (!fh) {
    errno = EBADF;
    return (EOF);
  }
  if (size <= 0) {
    errno = EINVAL;
    return (EOF);
  }

  pa.PP_Code = DOSBase;
  pa.PP_Offset = -48;  /* _LVOWrite */
  pa.PP_Flags = pa.PP_StackSize = 0;
  pa.PP_Stack = NULL;
  pa.PP_Regs[PPREG_D1] = (ULONG)fh;
  pa.PP_Regs[PPREG_D2] = (ULONG)buf;
  pa.PP_Regs[PPREG_D3] = (ULONG)size;
  pa.PP_Regs[PPREG_A6] = (ULONG)DOSBase;
  Run68k(&pa);

  if ((n = (long)pa.PP_Regs[PPREG_D0]) == -1) {
    errno = EIO;
    return (EOF);
  }
  return (n);
}
